﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.Runtime;
using System.Workflow.Activities;

namespace WF_Executor
{
    class Program
    {
        static void Main(string[] args)
        {
            WfExecutor wfe = new WfExecutor();
            wfe.Execute();

            Console.Read();
        }
    }

    public class WfExecutor
    {
        private WorkflowRuntime wfr;
        private ExternalDataExchangeService edes;
        private System.Threading.AutoResetEvent waitHandler;

        public WfExecutor()
        {
            wfr = new WorkflowRuntime();
            edes = new ExternalDataExchangeService();
            wfr.AddService(edes);

            waitHandler = new System.Threading.AutoResetEvent(false);

            wfr.Started += delegate { Console.WriteLine("WorkflowRuntime is started."); };
            wfr.Stopped += delegate { Console.WriteLine("Workflow is stroped."); };
            wfr.WorkflowTerminated += delegate { waitHandler.Reset(); };
        }

        public void Execute()
        {
            wfr.StartRuntime();
            WorkflowInstance ins = wfr.CreateWorkflow(typeof(UsingWF.Workflow1));
            waitHandler.Set();
            ins.Start();
            waitHandler.WaitOne();
            wfr.StopRuntime();
            waitHandler.Reset();
            waitHandler.Close();
        }
    }
}
